
/*---------------------------------------------------------------------------*
 *  VARIABLES                                                                *
 *---------------------------------------------------------------------------*/
#include "math.h"

uint32 _math_rand_seed = 0x600D5EED;

void math_rand_set_seed (uint32 seed) {
	_math_rand_seed = seed;
}

uint32 math_rand_get_seed () {
	return _math_rand_seed;
}

uint16 math_rand (uint16 max) {
	uint32 rnd;
	uint32 div;

	if (max > 0x7FFF) {
		max = 0x7FFF;
	}

	div = 0x8000 / (max + 1);

	_math_rand_seed = _math_rand_seed * 1103515245 + 12345;
	rnd = (_math_rand_seed >> 16) & 0x7FFF;

	return rnd / div;
}

